DROP TABLE IF EXISTS TB_ARCHIVER_INFO;
CREATE TABLE TB_ARCHIVER_INFO (
    VERSION_NUMBER varchar(100) NOT NULL,
    TITLE varchar(100) NOT NULL,
    USER_ID varchar(100) NOT NULL
) WITH (oids = false);

INSERT INTO TB_ARCHIVER_INFO (VERSION_NUMBER, TITLE, USER_ID) VALUES
('Raspberry PI v1.0',	'Raspberry Pi   ý',	'ADMIN');


DROP TABLE IF EXISTS TB_USERS;
CREATE TABLE TB_USERS (
  USERNAME varchar(100) NOT NULL DEFAULT '',
  NAME varchar(500) NOT NULL,
  PASSWORD varchar(500) NOT NULL,
  USERROLE varchar(3) NOT NULL,
  CREADATE date NOT NULL,
  DEL_GB varchar(1) NOT NULL,
  MESSAGE varchar(1000) NOT NULL
) WITH (oids = false);
INSERT INTO TB_USERS (USERNAME, NAME, PASSWORD, USERROLE, CREADATE, DEL_GB, MESSAGE) VALUES
('guest', 'guest', 'guest', 'gst', '2020-06-22 20:33:19', 'N', 'GUEST'),
('archiveradmin', 'archiveradmin', 'archiveradmin', 'adm', '2019-01-10 00:00:00', 'N', 'Hello !');

DROP TABLE IF EXISTS TB_FILEMANAGER_META;
CREATE SEQUENCE SEQ_META;
CREATE TABLE TB_FILEMANAGER_META (
  IDX int not null default nextval('SEQ_META'),
  USER_ID varchar(100) NOT NULL,
  META varchar(1000) NOT NULL,
  CREA_DTM date NOT NULL,
  CREA_ID varchar(100) NOT NULL,
  DEL_GB varchar(1) NOT NULL DEFAULT 'N'
)WITH (oids = false);
ALTER SEQUENCE SEQ_META OWNED BY TB_FILEMANAGER_META.IDX; 

DROP TABLE IF EXISTS TB_FILEMANAGER_META_MAPPING;
CREATE SEQUENCE SEQ_META_MAPP;
CREATE TABLE TB_FILEMANAGER_META_MAPPING (
  IDX int NOT NULL DEFAULT NEXTVAL('SEQ_META_MAPP'),
  USER_ID varchar(100) NOT NULL,
  META_IDX int NOT NULL,
  FILE_IDX int NOT NULL,
  CREA_DTM date NOT NULL,
  CREA_ID varchar(100) NOT NULL,
  DEL_GB varchar(1) NOT NULL DEFAULT 'N'
)WITH (oids = false);
ALTER SEQUENCE SEQ_META_MAPP OWNED BY TB_FILEMANAGER_META_MAPPING.IDX; 

DROP TABLE IF EXISTS TB_FILEMANAGER_META_FILE;
CREATE SEQUENCE SEQ_FILE;
CREATE TABLE TB_FILEMANAGER_META_FILE (
  IDX int not null default nextval('SEQ_FILE'),
  FILE_TITLE varchar(1000) NOT NULL,
  FILE_DETAIL varchar(4000) NOT NULL,
  ORIGINAL_FILE_NAME varchar(500) NOT NULL,
  STORED_FILE_NAME varchar(1000) NOT NULL,
  FILE_SIZE bigint NOT NULL,
  FILE_TYPE varchar(10) NOT NULL,
  CREA_DTM date NOT NULL,
  CREA_ID varchar(100) NOT NULL,
  DEL_GB varchar(1) NOT NULL DEFAULT 'N',
  OPN_GB varchar(2) NOT NULL DEFAULT 'N'
)WITH (oids = false);
ALTER SEQUENCE SEQ_FILE OWNED BY TB_FILEMANAGER_META_FILE.IDX; 


DROP TABLE IF EXISTS TB_FILEMANAGER_META_REF;
CREATE TABLE TB_FILEMANAGER_META_REF (
  FROM_IDX int NOT NULL,
  TO_IDX int NOT NULL,
  META_REF int NOT NULL,
  CREA_DTM date NOT NULL,
  CREA_ID varchar(100) NOT NULL,
  DEL_GB varchar(1) NOT NULL DEFAULT 'N',
  UPDT_DTM date DEFAULT NULL
) WITH (oids = false);