<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<html>
<head>

<%@ include file="/WEB-INF/include/include-header.jspf" %>

<title>${ title }</title>
<!-- https://visjs.github.io/vis-network/docs/network/ -->
<link href="<c:url value='/css/jquerysctipttop.css'/>" rel="stylesheet" type="text/css">
<link href="<c:url value='/css/css?family=Roboto+Condensed'/>" rel='stylesheet' type='text/css'>

  <style type="text/css">
    html, body {
      font: 14pt arial;
    }
    #mynetwork {
      width: 100%;
      height: 70%;
      border: 1px solid lightgray;
    }
  </style>

  <script src="<c:url value='/js/vis-network.js'/>"></script>
  
  

  <script type="text/javascript">
    var nodes = null;
    var edges = null;
    var network = null;

    function draw() {
      // create people.
      // value corresponds with the age of the person
      nodes = [
	  		<c:choose>
			<c:when test="${fn:length(list) > 0}">
				<c:forEach items="${list }" var="metaVO">
						{id: ${metaVO.idx },  value: ${metaVO.countMeta },  label: '${metaVO.meta }' },
				</c:forEach>
			</c:when>
			<c:otherwise>
				<a href="#" rel='0'> <span> 조회된 결과가 없습니다.<sup>0</sup> </span> </a>
			</c:otherwise>
			</c:choose>
      ];

      // create connections between people
      // value corresponds with the amount of contact between two people
      edges = [
			<c:choose>
				<c:when test="${fn:length(metaref) > 0}">
					<c:forEach items="${metaref }" var="metaRef">
							{
							 from: ${metaRef.fromIdx },  
							 to: ${metaRef.toIdx },  
							 label:"${metaRef.metaRef }",
							 value: ${metaRef.metaRef }, 
							 arrows:"to" 
							},
					</c:forEach>
				</c:when>
				<c:otherwise>
					{
						 from: 1,  
						 to: 1,  
						 label:"NoData",
						 value: "NoData", 
						 arrows:"to" 
						},	
				</c:otherwise>
			</c:choose>
      ];

      // Instantiate our network object.
      var container = document.getElementById('mynetwork');
      var data = {
        nodes: nodes,
        edges: edges
      };
      var options = {
        nodes: {
          //shape: 'dot',
		  shape: 'oval',
          scaling: {
            customScalingFunction: function (min,max,total,value) {
              return value/total;
            },
            min:20,
            max:500
          }
        }
      };
      network = new vis.Network(container, data, options);
	  network.on("click", function (params) {
		if(params.nodes != "")
		{
			fn_searchFileByMeta(params.nodes);
		}
	  });
  
    }
  </script>
  
</head>
<body onload="draw()">
	<center>
    <div class="container">
        <font size=5><B>${ title }</B></font>    
		<a href="#this" class="btn btn-success" id="searchMetaBtn" onclick="fn_searchMetaKey();">메타검색</a>
		<a href="#this" class="btn btn-success" id="searchFileBtn" onclick="fn_searchFileKey();">파일검색</a>
		<br>
		
		<c:choose>
			<c:when test="${username ne 'guest'}">
				<font size=3> Meta : <input type="text" id="from_meta" size=10> <img src="<c:url value='/images/rightArrow.png'/>" height="17" width="30"> <input type="text" id="to_meta" size=10> : Ref level</font><font size=1>(0 no ref ~ 10 same, 0 is delete ref)</font>  <input type="text" id="meta_ref" size=3> <a href="#this" class="btn btn-success" name="metaRefSubmit" >Meta 관계 적용</a>
			</c:when>
			<c:otherwise>
				메타 정보 				
			</c:otherwise>
		</c:choose>
		<br>
		<font size=1>
		> 0:관계 삭제 <br>
		> 1:참조 관계, 2:Only 참조 관계, 3:밀접 연관, 4:Only 밀접 연관<br>
        > 5:부분 포함, 6:Only 부분 포함 <br>
        > 7:부분 동일, 8:Only 부분 동일 , 9:전체 포함, 10:Only 전체 포함<br>
        </font> 
		<br>
				
			<div id="mynetwork"></div>

		<br>
		<I><B>${version} By 꼬가족 <a href="#this" class="btn" id="update">업데이트</a></B></I>        
	</div>
	<div align="left" style="width:50%;">
		- 업데이트 후 tomcat webapps 폴더로 복사 : /app/apache-tomcat-9.0.64/webapps 로 복사 <br>
		- 시스템 재시작 : sudo systemctl restart tomcat.service
	</div> 
	</center>
	
	<%@ include file="/WEB-INF/include/include-body.jspf" %>
    <script type="text/javascript">
        $(document).ready(function(){
			
            $("a[name='metaRefSubmit']").on("click", function(e){ //제목
                e.preventDefault();
                fn_metaRefSubmit($(this));
            });
			
			$("#update").on("click", function(e){ 
                e.preventDefault();
                fn_openBoardList();
            });
            
        });
		
		
		function fn_searchMetaKey(){
            var comSubmit = new ComSubmit();
			comSubmit.setUrl("<c:url value='/searchMetaList.do' />");
            comSubmit.addParam("searchKey", "");
            comSubmit.submit(); 
        }

		function fn_searchFileKey(){
            var comSubmit = new ComSubmit();
			comSubmit.setUrl("<c:url value='/searchFileByMeta.do' />");
            comSubmit.addParam("searchKey", "");
            comSubmit.submit(); 
        }
		
		function fn_metaRefSubmit(obj){
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/updateMetaRef.do' />");
			if(
				obj.parent().find("#from_meta").val() == "" ||
				obj.parent().find("#to_meta").val() == "" ||
				obj.parent().find("#meta_ref").val() == ""
			){
				alert("Please input from meta and to meta and ref level ! ");
				return;
			}
			if(
				confirm(" > Meta from : " + 
					obj.parent().find("#from_meta").val() + 
					" ->  to : " + 
					obj.parent().find("#to_meta").val() +
					", ref : " + obj.parent().find("#meta_ref").val())
			)
			{
				comSubmit.addParam("fromMeta", obj.parent().find("#from_meta").val());
				comSubmit.addParam("toMeta", obj.parent().find("#to_meta").val());
				comSubmit.addParam("metaRef", obj.parent().find("#meta_ref").val());
				comSubmit.submit();
			}
        }

		function fn_searchFileByMeta(idx){
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/searchFileByMeta.do' />");
			comSubmit.addParam("idx", idx);
            comSubmit.addParam("index", "0");
            comSubmit.submit();
        }

		function fn_openBoardList(){
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/common/updateSystem.do' />");
            comSubmit.submit();
        }

	</script>
		

<script src="<c:url value='/js/tagcloud.js'/>"></script>
<script>
        $("#tagcloud a").tagcloud();

        $('#tagForm').submit(function() {
            $("#tagcloud a").tagcloud({
                size: {
                    start: parseInt($('#minFont').val()),
                    end: parseInt($('#maxFont').val()),
                    unit: $('#unit').val()
                },
                color: {
                    start: "#" + $('#startColour').val(),
                    end: "#" + $('#endColour').val()
                }
            })
            return false;
        })

    </script>
<script type="text/javascript">

  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', 'UA-36251023-1']);
  _gaq.push(['_setDomainName', 'jqueryscript.net']);
  _gaq.push(['_trackPageview']);

  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();

</script>
</body>
</html>
