<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="ko">
<head>
<%@ include file="/WEB-INF/include/include-header.jspf" %>

	<c:forEach items="${cu.authorities}" var="role">
		<c:if test="${role.name eq 'adm' || role.name eq 'nor'}">
			<c:set var="permission" scope="session" value="permit" />
		</c:if>
	</c:forEach>

	
</head>
<body>
<center>
	<div class="container">
    <table class="board_view">
        <colgroup>
            <col width="15%"/>
            <col width="35%"/>
            <col width="15%"/>
            <col width="35%"/>
        </colgroup>
        <caption>게시글 상세</caption>
        <tbody>
            <tr>
                <th scope="row">글 번호</th>
                <td>${filevo.idx }</td>
                <th scope="row">삭제여부</th>
                <td>${filevo.delGb }</td>
            </tr>
            <tr>
                <th scope="row">작성자</th>
                <td>${filevo.creaId }</td>
                <th scope="row">작성시간</th>
                <td>${filevo.creaDtm }</td>
            </tr>
            <tr>
                <th scope="row">파일 요약</th>
                <td colspan="3">${filevo.fileTitle }</td>
            </tr>
            <tr>
                <td colspan="4">${filevo.fileDetail }</td>
            </tr>
			<tr>
			    <td colspan="4" class="view_text">
			         <select id="opn_gb">
					    <option value="N" selected>PRIVATE</option>
					    <option value="Y">OPEN</option>
					</select> ※  OPEN은 전체 공유 
			    </td>
			</tr>
			<tr>
			    <td colspan="4" class="view_text">
			         <select id="file_type">
					    <option value="doc" selected>DOC</option>
						    <option value="mov">MOVIE</option>
						    <option value="muc">MUSIC</option>
						    <option value="pic">PICTURE</option>
						    <option value="exe">PROGRAM</option>
						    <option value="etc">ETC</option>
					</select> 
			    </td>
			</tr>
			<tr>
				<td colspan="4" class="view_text">
				    Download Status : ${filevo.downYn}<br>
					<c:choose>
						<c:when test="${filevo.fileType eq 'mov' and filevo.downYn eq 'Y'}">
								<video class="video" width="640" height="480" controls>
									<source src="<c:url value='/sourceContens.do?idx=${filevo.idx}' />" type="video/mp4">
								</video>
						</c:when>	
						<c:when test="${filevo.fileType eq 'mov' and ( filevo.downYn eq 'N' or filevo.downYn eq 'D')}">
								<c:set var="urlName" value="${fn:split(filevo.originalFileName, '/')}" />
								<iframe width="560" height="315" 
									src="https://www.youtube.com/embed/${urlName[fn:length(urlName)-1]}" 
									title="YouTube video player" frameborder="0" 
									allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" 
									allowfullscreen>
								</iframe>
						</c:when>	
						<c:when test="${filevo.fileType eq 'muc'}">
							<audio controls>
								<source src="<c:url value='/sourceContens.do?idx=${filevo.idx}' />" type="audio/mpeg">
							</audio>							
						</c:when>
						<c:when test="${filevo.fileType eq 'pic'}">
							  <img src="<c:url value='/sourceContens.do?idx=${filevo.idx}' />" class="img-fluid img-thumbnail" alt="${filevo.fileTitle }">
						</c:when>
					</c:choose>
				</td>
			</tr>
            <tr>
                <th scope="row">파일 정보</th>
                <td colspan="3">
                    <input type="hidden" id="idx" value="${filevo.idx }">
                    <a href="#this" name="file">${filevo.originalFileName }</a>
                    (${filevo.fileSize }kb)
                </td>
            </tr>
            <tr>
                <th scope="row">메타 정보</th>
                <td colspan="3">
					<table>
						<c:forEach var="row" items="${metalist }">
						<tr>
							<td>
							<input type="hidden" id="meta_idx" value="${row.meta }">
							<a href="#this" name="meta_idx">${row.meta }</a>
							</td>
						</tr>
						</c:forEach>
					</table>
                </td>
            </tr>
        </tbody>
    </table>
    </div>
    </center>
    <br/>
     
    <center>
    <a href="#this" class="btn" id="list">목록으로</a>
	<c:choose> 
		<c:when test="${permission eq 'permit'}">
			<a href="#this" class="btn" id="update">수정하기</a>
		</c:when> 
		<c:otherwise>
			수정 권한이 없습니다. 
		</c:otherwise> 
	</c:choose> 
	</center>
     
    <%@ include file="/WEB-INF/include/include-body.jspf" %>
    <script type="text/javascript">
        $(document).ready(function(){
			
			$("#opn_gb").val("${filevo.opnGb}").change();
			$("#opn_gb").attr('disabled', true);
			
			$("#file_type").val("${filevo.fileType}").change();
			$("#file_type").attr('disabled', true);

			$("#list").on("click", function(e){ //목록으로 버튼
                e.preventDefault();
                fn_openFileList();
            });
             
            $("#update").on("click", function(e){ //수정하기 버튼
                e.preventDefault();
                fn_openFileUpdate();
            });
             
            $("a[name='file']").on("click", function(e){ //파일 이름
            	e.preventDefault();
            	fn_downloadFile($(this));
        	});

            $("a[name='meta_idx']").on("click", function(e){ // 메타명 
            	e.preventDefault();
            	fn_searchMetaList($(this));
        	});

		});
         
        function fn_openFileList(){
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/searchFileByMeta.do' />");
			comSubmit.addParam("searchKey", "${searchKey}");
			comSubmit.addParam("index", "${index}");
			comSubmit.addParam("fileindex", "${fileindex}");
			comSubmit.submit();
        }
         
        function fn_openFileUpdate(){
            var idx = "${filevo.idx}";
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/openfileUpdate.do' />");
            comSubmit.addParam("idx", idx);
            comSubmit.submit();
        }
        
		function fn_downloadFile(obj){
	        var idx = obj.parent().find("#idx").val();
	        var comSubmit = new ComSubmit();
	        comSubmit.setUrl("<c:url value='/common/downloadFile.do' />");
	        comSubmit.addParam("idx", idx);
	        comSubmit.submit();
	    }
		
		function fn_searchMetaList(obj){
			var mi = obj.parent().find("#meta_idx").val();
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/searchMetaList.do' />");
            comSubmit.addParam("searchKey", mi);
            comSubmit.addParam("index", "0");
            comSubmit.submit();
        }

    </script>
</body>
</html>