<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="ko">
<head>
<%@ include file="/WEB-INF/include/include-header.jspf" %>
</head>
<body>
<center>
	<div class="container">
	<form id="frm" name="frm" enctype="multipart/form-data">
    <table class="board_view">
        <colgroup>
            <col width="15%"/>
            <col width="35%"/>
            <col width="15%"/>
            <col width="35%"/>
        </colgroup>
        <caption>게시글 상세</caption>
        <tbody>
            <tr>
                <th scope="row">글 번호</th>
                <td>${filevo.idx }</td>
                <th scope="row">삭제여부</th>
                <td>${filevo.delGb }</td>
            </tr>
            <tr>
                <th scope="row">작성자</th>
                <td>${filevo.creaId }</td>
                <th scope="row">작성시간</th>
                <td>${filevo.creaDtm }</td>
            </tr>
            <tr>
                <th scope="row">파일 요약</th>
                <td colspan="3"><input type="text" id="file_title" name="file_title" class="wdp_90" value="${filevo.fileTitle }"></input></td>
            </tr>
            <tr>
                <td colspan="4">
				<textarea rows="5" cols="100" title="내용" id="file_detail" name="file_detail" >${filevo.fileDetail }</textarea>
				</td>
            </tr>
            
            
			<tr>
			    <td colspan="4" class="view_text">
			         <select id="opn_gb">
					    <option value="N" selected>PRIVATE</option>
					    <option value="Y">OPEN</option>
					</select> ※ 주의 OPEN 선택 시에 전체 공유됩니다. 
			    </td>
			</tr>

        	<tr>
			    <td colspan="4" class="view_text">
			         <select id="file_type">
					    <option value="doc" selected>DOC</option>
					    <option value="mov">MOVIE</option>
					    <option value="muc">MUSIC</option>
					    <option value="pic">PICTURE</option>
					    <option value="exe">PROGRAM</option>
					    <option value="etc">ETC</option>
					</select> 
			    </td>
			</tr>
            
            
            <tr>
                <th scope="row">파일 정보</th>
                <td colspan="3">
					<div id="fileDiv">   
					<p>
						<input type="hidden" id="idx" name="idx_${filevo.idx }" value="${filevo.idx }">
						<a href="#this" name="file">${filevo.originalFileName }</a>  (${filevo.fileSize }kb)<br>
						<input type="file" id="file_${filevo.idx }" name="file_${filevo.idx }">
					</p>
					</dev>
                </td>
            </tr>
			
			
			
			
			<tr>
				<th scope="row">메타 정보</th>
				<td colspan="3">
					<div id="metaDiv">               
						<c:forEach var="row" items="${metalist }">
							<p>
								<input type="hidden" id="meta_idx_org" name='meta_idx_org' value="${row.meta }">
								<a href="#this" name="meta_idx_org">${row.meta }</a>
								<a href="#this" class="btn" name="delete">삭제</a>
							</p>
						</c:forEach>
					</div>
				</td>
			</tr>

			</tbody>
    </table>
    <br/>
	<input type="hidden" id="meta" value="">
    </form>
    </div>
     
    <a href="#this" class="btn" id="list">목록으로</a>
	<a href="#this" class="btn" id="addMeta">메타추가</a>
    <a href="#this" class="btn" id="update">수정하기</a>
	<a href="#this" class="btn" id="delete">삭제하기</a>
    </center>
         
    <%@ include file="/WEB-INF/include/include-body.jspf" %>
    <script type="text/javascript">
    
    
        $(document).ready(function(){
        
        	$("#opn_gb").val("${filevo.opnGb}").change();

        	$("#file_type").val("${filevo.fileType}").change();

            $("#list").on("click", function(e){ //목록으로 버튼
                e.preventDefault();
                fn_openMetaList();
            });
			
            $("#addMeta").on("click", function(e){ //메타 추가 버튼
                e.preventDefault();
                fn_addMeta();
            });
              
            $("#update").on("click", function(e){ //수정하기 버튼
                e.preventDefault();
                fn_updateFile();
            });
             
            $("a[name='file']").on("click", function(e){ //파일 이름
            	e.preventDefault();
            	fn_downloadFile($(this));
        	});

            $("a[name='meta_idx_org']").on("click", function(e){ // 메타명 
            	e.preventDefault();
            	fn_searchMetaList($(this));
        	});

			$("a[name='delete']").on("click", function(e){ //삭제 버튼
                e.preventDefault();
                fn_deleteMeta($(this));
            });

			$("#delete").on("click", function(e){ //삭제하기 버튼
				e.preventDefault();
				fn_deleteBoard();
			});
		});
         
        function fn_openMetaList(){
			var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/searchMetaList.do' />");
            comSubmit.addParam("searchKey", '${searchKey}');
            comSubmit.addParam("index", "0");
            comSubmit.submit();
        }
         
		function fn_addMeta(){
            var str = "<P><input type='text' id='meta' name='meta' class='wdp_50'></input> <a href='#this' class='btn' name='delete'>삭제</a></P>";
            $("#metaDiv").append(str);
            $("a[name='delete']").on("click", function(e){ //삭제 버튼
                e.preventDefault();
                fn_deleteMeta($(this));
            });
        }

        function fn_deleteMeta(obj){
            obj.parent().remove();
        }
 
        function fn_updateFile(){
            var idx = "${filevo.idx }";
			//getList();
			if( isEmpty($('#meta').val()) && isEmpty($('#meta_idx_org').val())){
				alert("Meta 정보가 없습니다. Meta는 하나 이상이어야 합니다. ");
				return;
			}
            var comSubmit = new ComSubmit("frm");
			if(confirm("Update this article ? ")){
				comSubmit.setUrl("<c:url value='/updateFile.do' />");
				comSubmit.addParam("idx", idx);
				comSubmit.addParam("opn_gb", $("#opn_gb option:selected").val());
				comSubmit.addParam("file_type", $("#file_type option:selected").val());
				//comSubmit.addParam("meta", $('#meta').val());
				comSubmit.submit();
				return;
			}else{
				return;
			}
        }
		/*
		function getList(){
			var arr = [];
			// input 배열 Loop
			$.each($("input[name='meta_idx_org']"),function(k,v) {
				arr[arr.length] = $(v).val();
			});
			$("#meta").val(arr);
		}
        */
		function fn_downloadFile(obj){
	        var idx = obj.parent().find("#idx").val();
	        var comSubmit = new ComSubmit();
	        comSubmit.setUrl("<c:url value='/common/downloadFile.do' />");
	        comSubmit.addParam("idx", idx);
	        comSubmit.submit();
	    }
		
		function fn_searchMetaList(obj){
			var mi = obj.parent().find("#meta_idx_org").val();
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/searchMetaList.do' />");
            comSubmit.addParam("searchKey", mi);
            comSubmit.addParam("index", "0");
            comSubmit.submit();
        }
		
		function fn_deleteBoard(){
			var comSubmit = new ComSubmit();
			var idx = "${filevo.idx }";
			comSubmit.setUrl("<c:url value='/deleteFile.do' />");
			comSubmit.addParam("idx", idx);
			comSubmit.submit();
		}

		/**
		* 문자열이 빈 문자열인지 체크하여 결과값을 리턴한다.
		* @param str       : 체크할 문자열
		*/
		function isEmpty(str){
			if(typeof str == "undefined" || str == null || str == "")
				return true;
			else
				return false ;
		}

    </script>
</body>
</html>