<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="ko"> 
<head>
<%@ include file="/WEB-INF/include/include-header.jspf" %>

	<c:forEach items="${cu.authorities}" var="role">
		<c:if test="${role.name eq 'adm' || role.name eq 'nor'}">
			<c:set var="permission" scope="session" value="permit" />
		</c:if>
	</c:forEach>

	
  <script src="<c:url value='/js/vis-network.js'/>"></script>
  
    <style type="text/css">
    #mynetwork {
      width: 80%;
      height: 200px;
      border: 1px solid lightgray;
    }
  </style>

  <script type="text/javascript">
    var nodes = null;
    var edges = null;
    var network = null;

    function draw() {
      // create people.
      // value corresponds with the age of the person
	  
	  <c:set var="duplicationCheck" value="true" />
	  <c:set var="checkDuplVar" value="0" />

      nodes = [
			<c:choose>
			<c:when test="${fn:length(refMetaList) > 0}">
			
				<c:choose>
					<c:when test="${fn:length(list) > 0}">
						<c:forEach items="${list }" var="list">
							{id: ${list.idx },  value: 1,  label: '${list.meta }' },
						</c:forEach>
					</c:when>
					<c:otherwise>
					</c:otherwise>
				</c:choose>
				
				<c:forEach items="${refMetaList }" var="refMetaVO">
					// list exist check ----
					<c:choose>
						<c:when test="${fn:length(list) > 0}">
							<c:forEach items="${list }" var="list">
								<c:if test="${refMetaVO.idx eq list.idx}">
									<c:set var="duplicationCheck" value="false" />
								</c:if>	
							</c:forEach>
						</c:when>
						<c:otherwise>
						</c:otherwise>
					</c:choose>	
					// list exist check  ----
					// Cross reference check ----
					<c:choose>
						<c:when test="${fn:length(refMetaList) > 0}">
							<c:forEach items="${refMetaList}" var="refMetaVO2">
								<c:if test="${refMetaVO2.idx eq refMetaVO.idx}">
									<c:set var="checkDuplVar" value="${checkDuplVar + 1}" />
									// <c:out value='${refMetaVO2.idx}' /> , <c:out value='${refMetaVO.idx}' />, <c:out value='${checkDuplVar}' /> 
								</c:if>	
							</c:forEach>
						</c:when>
						<c:otherwise>
						</c:otherwise>
					</c:choose>	
					// Cross reference check ----
					<c:if test="${duplicationCheck eq 'true' && checkDuplVar == '1'}">
						{id: ${refMetaVO.idx },  value: ${refMetaVO.metaRef },  label: '${refMetaVO.meta }' },
					</c:if>
					<c:set var="duplicationCheck" value="true" />
					<c:set var="checkDuplVar" value="0" />
				</c:forEach>
				
			</c:when>
			<c:otherwise>
				<a href="#" rel='0'><span>조회된 결과가 없습니다.<sup>0</sup></span></a>
			</c:otherwise>
			</c:choose>
      ];

      // create connections between people
      // value corresponds with the amount of contact between two people
      edges = [
			<c:choose>
				<c:when test="${fn:length(refMetaList) > 0}">
					<c:forEach items="${refMetaList }" var="refMetaVO">
							{
							 from: ${refMetaVO.fromIdx },  
							 to: ${refMetaVO.toIdx },  
							 label:"${refMetaVO.metaRef }",
							 value: ${refMetaVO.metaRef }, 
							 arrows:"to" 
							},
					</c:forEach>
				</c:when>
				<c:otherwise>
					{
						 from: 1,  
						 to: 1,  
						 label:"NoData",
						 value: "NoData", 
						 arrows:"to" 
						},
				</c:otherwise>
			</c:choose>
      ];

      // Instantiate our network object.
      var container = document.getElementById('mynetwork');
      var data = {
        nodes: nodes,
        edges: edges
      };
      var options = {
        nodes: {
          //shape: 'dot',
		  shape: 'oval',
          scaling: {
            customScalingFunction: function (min,max,total,value) {
              return value/total;
            },
            min:20,
            max:500
          }
        }
      };
      network = new vis.Network(container, data, options);
	  network.on("click", function (params) {
		if(params.nodes != "")
		{
			fn_searchFileByMetaOnNetwork(params.nodes);
		}
	  });
  
    }
  </script>
 
 
</head>
<body>
	<center>
	
	<div class="container">
		<table>
			<thead>
			<tr>
				<td colspan=3>
					<h2>
						<c:out value="${cu.username}"/>
						<a href="<c:url value='/dashboard.do'/>" id="searchKeyBtn" onclick="#">메타 목록</a>&nbsp;&nbsp;
						<input type="txt" id="searchKey" name="searchKey" value="${searchKey}"> <a href="#this" class="btn" id="searchKeyBtn" onclick="fn_searchMetaKey();">메타 검색</a> <a href="#this" class="btn" id="#" onclick="$(searchKey).val('');fn_searchMetaKey();" >초기화</a>
					</h2>					
				</td>
			</tr>
			<tr>
				<td>
					<font size="2">복수 검색 가능 예) "검색어1 검색어2" 공백으로 검색어 분리</font>
				</td>
				<td colspan=2>
					<font size=3>&nbsp;&nbsp;<a href="<c:url value='/dashboard.do'/>" class="btn" id="#" onclick="#" >메타 온톨로지(Ontology)</a> </font>
					<font size=3>&nbsp;&nbsp;<a href="#this" class="btn" id="searchFileBtn" onclick="fn_searchFileKey();" >파일 목록</a></font>
				</td>
			</tr>
			</thead>
		</table>
	</div>
	<br>
	
	<div id="mynetwork"></div>
	
	<div class="container">
		<table class="board_list">
			<colgroup>
				<col width="10%"/>
				<col width="10%"/>
				<col width="*"/>
				<col width="15%"/>
				<col width="20%"/>
			</colgroup>
			<thead>
				<tr>
					<th scope="col">통합 메타</th>
					<th scope="col">선택</th>
					<th scope="col">메타 번호</th>
					<th scope="col">메타 정보</th>
					<th scope="col">파일 수</th>
					<th scope="col">생성자</th>
					<th scope="col">생성일</th>
				</tr>
			</thead>
			<tbody>
				<c:choose>
					<c:when test="${fn:length(list) > 0}">
						<c:forEach items="${list }" var="list">
							<tr>
								<td><input type="radio" id="targetMeta" name="targetMeta" value="${list.idx }"></td>
								<td><input type="checkbox" id="idxCheck" name="idxCheck" value="${list.idx }"></td>
								<td>${list.idx }</td>
								<td class="title">
									<a href="#this" name="title" value="${list.meta }" >${list.meta }</a>
									<input type="hidden" id="idx" value="${list.idx }">
								</td>
								<td>${list.countMeta }</td>
								<td>${list.creaId }</td>
								<td>${list.creaDtm }</td>
							</tr>
						</c:forEach>
					</c:when>
					<c:otherwise>
						<tr>
							<td colspan="4">조회된 결과가 없습니다.</td>
						</tr>
					</c:otherwise>
				</c:choose>
			</tbody>
		</table>
     </div>
	 <BR><BR>
	<c:if test="${permission eq 'permit'}">
		<a href="#this" class="btn" id="write">파일+메타 등록</a> .  
		<a href="#this" class="btn" id="merge">메타 Merge</a> . 
	</c:if>
	<a href="#this" class="btn" id="vlcExec">VLC실행</a>
	</center>
	
   <!-- 5. paging view --> 
   <center>   
        <ul class="pagination">
            <c:if test="${p.viewFirstPage ne 1}">
                <!--맨 첫페이지 이동 -->
                <li><a onclick='pagePre(0,${p.count_per_page});'>«</a></li>
                <!--이전 페이지 이동 -->
                <li><a onclick='pagePre(${p.viewFirstPage-1},${p.count_per_page});'>‹</a></li>
            </c:if>
            
            <!--페이지번호 -->
            <c:forEach var='i' begin="${p.viewFirstPage}" end="${p.viewLastPage}" step="1">
				<li class='pageIndex${i}'><a onclick='pageIndex(${i});'>${i}</a></li>
            </c:forEach>
            
            <c:if test="${p.lastChk}">
                <!--다음 페이지 이동 -->
                <li><a onclick='pageNext(${p.viewLastPage},${p.total_list_count},${p.count_per_list},${p.count_per_page});'>›</a></li>
                <!--마지막 페이지 이동 -->
                <li><a onclick='pageLast(${p.viewFirstPage},${p.total_list_count},${p.count_per_list},${p.count_per_page});'>»</a></li>
            </c:if>
        </ul>
        <form action="./paging.do" method="post" id='frmPaging'>
            <!--출력할 페이지번호, 출력할 페이지 시작 번호, 출력할 리스트 갯수 -->
            <input type='hidden' name='index' id='current_page_no' value='${p.current_page_no}'>
            <input type='hidden' name='viewFirstPage' id='viewFirstPage' value='${p.viewFirstPage}'>
            <input type='hidden' name='count_per_list' id='count_per_list' value='${p.count_per_list}'>    
        </form>
    총 메타 : ${p.total_list_count} 건 
    </center>
   <!-- 5. paging view --> 

	<center>
    <div th:if="${cu}">
		<c:forEach items="${cu.authorities}" var="role">
			<c:if test="${role.name eq 'adm'}">
				[<a href="#this" id="reguser"> 사용자 등록 </a>] .
				<div id="userDiv" class="container" >
					<BR>
					<select id="userrole">
						<option value="nor" selected>Normal</option>
						<option value="gst">Guest</option>
						<option value="adm">Administrator</option>
					</select> 
					ID(email) : <input type="text" id="username" name="username" class="wdp_30"></input> PASSWD : <input type="text" id="password" name="password" class="wdp_10"></input>
					NAME : <input type="text" id="name" name="name" class="wdp_6"></input> Message : <input type="text" id="message" name="message" class="wdp_30"></input>   
					<a href="#this" class="btn" id="adduser"> 사용자 등록 </a><br><br>[<a href="#this" id="deluser"> 사용자 삭제 </a>]
				</div>	
			</c:if>
		</c:forEach>
    </div>
	</center>

   <%@ include file="/WEB-INF/include/include-body.jspf" %>
    <script type="text/javascript">
		var userDiv = false;
		$("#userDiv").css("display", "none");
	
        $(document).ready(function(){
            $("#write").on("click", function(e){ //글쓰기 버튼
                e.preventDefault();
                fn_openBoardWrite();
            });
			
            $("a[name='title']").on("click", function(e){ //제목
                e.preventDefault();
                fn_searchFileByMeta($(this));
            });
            
            $("#merge").on("click", function(e){ //제목
				var cfm = confirm('Are you sure you want to do this?'); 
				if(cfm){
					e.preventDefault();
					fn_metaMerge();
				}
            });
            
            $("#vlcExec").on("click", function(e){ //파일 이름
            	e.preventDefault();
            	fn_ExecVLC($(this));
        	});

            $("#reguser").on("click", function(e){ //파일 이름
            	e.preventDefault();
				if(userDiv){
					$("#userDiv").css("display", "none");
					userDiv = false;
				}else{
					$("#userDiv").css("display", "block");
					userDiv = true;
				}
        	});
            
            $("#adduser").on("click", function(e){ //파일 이름
            	e.preventDefault();
            	if(confirm("사용자를 등록하시겠습니까 ? ")){
					fn_registUser();
				}else{
					alert("등록 취소");
				}
        	});
			
            $("#deluser").on("click", function(e){ //파일 이름
            	e.preventDefault();
            	if(confirm("사용자를 삭제하시겠습니까 ? ")){
					fn_deleteUser();
				}else{
					alert("삭제 취소");
				}
        	});
        });
         
         
        function fn_openBoardWrite(){
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/metaWrite.do' />");
            comSubmit.submit();
        }
		
		function fn_searchMetaKey(){
            var comSubmit = new ComSubmit();
			comSubmit.setUrl("<c:url value='/searchMetaList.do' />");
            //comSubmit.addParam("index", ${p.current_page_no}); 메타 검색 시에 현재 페이지 위치는 초기화 
            comSubmit.addParam("searchKey", $("#searchKey").val());
            comSubmit.submit(); 
        }

		function fn_searchFileKey(){
            var comSubmit = new ComSubmit();
			comSubmit.setUrl("<c:url value='/searchFileByMeta.do' />");
            comSubmit.addParam("searchKey", "");
            comSubmit.addParam("index", ${p.current_page_no});
            comSubmit.submit(); 
        }

         
        function fn_searchFileByMeta(obj){
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/searchFileByMeta.do' />");
            comSubmit.addParam("idx", obj.parent().find("#idx").val());
            comSubmit.addParam("searchKey", obj.attr("value"));
            comSubmit.addParam("index", ${p.current_page_no});
            comSubmit.submit();
        }
		
		function fn_searchFileByMetaOnNetwork(idx){
            var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/searchFileByMeta.do' />");
			comSubmit.addParam("idx", idx);
            comSubmit.addParam("index", "0");
            comSubmit.submit();
        }

		
		// index 리스트 처리
		function pageIndex(index) {
			var comSubmit = new ComSubmit();
			comSubmit.setUrl("<c:url value='/searchMetaList.do' />");
			comSubmit.addParam("index", index-1);
			comSubmit.submit();
		}
		
		
		function fn_metaMerge(){
		
			var checked = []
			$("input[name=idxCheck]:checked").each(function() {
				var tmp = $(this).val();
				alert(tmp);
				checked.push(tmp);
			});
			
			var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/metaMerge.do' />");
			comSubmit.addParam("idxCheck", checked);
			comSubmit.addParam("targetMeta", $(":input:radio[name=targetMeta]:checked").val());
            comSubmit.addParam("searchKey", $("#searchKey").val());
            comSubmit.addParam("index", ${p.current_page_no});
            comSubmit.submit();
        }


		function fn_ExecVLC(obj){
	        var comSubmit = new ComSubmit();
	        comSubmit.setUrl("<c:url value='/common/execVlc.do' />");
	        comSubmit.addParam("searchKey", $("#searchKey").val());
	        comSubmit.submit();
	    }
		


		
		// 이전 페이지 index
		function pagePre(firstPage, pageCnt) {
			var comSubmit = new ComSubmit();
			comSubmit.setUrl("<c:url value='/searchMetaList.do' />");
		    if (0 <= firstPage - pageCnt) {
		        //index -= pageCnt;
		        //comSubmit.addParam("pageStartNum", index);
		        comSubmit.addParam("index", firstPage-1);
		        comSubmit.submit();
		    }else{
		        comSubmit.addParam("index", 0);
		        comSubmit.submit();
			}
		}
		
		// 다음 페이지 index
		//pageNext(${p.current_page_no},${p.total_list_count},${p.count_per_list},${p.count_per_page});
		function pageNext(lastPage, total, listCnt, pageCnt) {
			var comSubmit = new ComSubmit();
			comSubmit.setUrl("<c:url value='/searchMetaList.do' />");
		    var totalPageCnt = Math.ceil(total / listCnt);
		    var max = Math.ceil(totalPageCnt / pageCnt);
			if (max * pageCnt >= lastPage + pageCnt) {
				//alert(lastPage);
				comSubmit.addParam("index", lastPage);
		        comSubmit.submit();
		    }
		}
		
		// 마지막 페이지 index
		function pageLast(index, total, listCnt, pageCnt) {
			var comSubmit = new ComSubmit();
			comSubmit.setUrl("<c:url value='/searchMetaList.do' />");
		    var totalPageCnt = Math.ceil(total / listCnt);
		    var max = Math.ceil(totalPageCnt / pageCnt);
		    while (max * pageCnt > index + pageCnt) {
		        index += pageCnt;
		    }
		    var remainListCnt = total - listCnt * (index - 1);
		    var remainPageCnt = Math.floor(remainListCnt / listCnt);
		    if (remainListCnt % listCnt != 0) {
		        remainPageCnt++;
		    }
		    var pageLastNum = 0;
		    if (remainListCnt <= listCnt) {
		        pageLastNum = index;
		    } else if (remainPageCnt <= pageCnt) {
		        pageLastNum = remainPageCnt + index - 1;
		    } else {
		        pageLastNum = pageCnt + index - 1;
		    }
	        comSubmit.addParam("pageStartNum", index);
	        comSubmit.addParam("index", pageLastNum - 1);
	        comSubmit.submit();
		}
        
		function fn_registUser(){
			var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/registUser.do' />");
			alert(
				 "CREATE USER \n" +
				 "userrole = " + $("#userrole option:selected").val() + "\n" +
				 "search = " + $("#searchKey").val() + "\n" +
				 "id(username) = " + $("#username").val() + "\n" +
				 "name = " +  $("#name").val() + "\n" +
				 "password = " +  $("#password").val() + "\n" +
				 "message = " +  $("#message").val() + "\n" +
				 "index = " +  ${p.current_page_no} + "\n" 
			 );
            comSubmit.addParam("searchKey", $("#searchKey").val());
            comSubmit.addParam("index", ${p.current_page_no});
			comSubmit.addParam("username", $("#username").val());
			comSubmit.addParam("name", $("#name").val());
			comSubmit.addParam("password", $("#password").val());
			comSubmit.addParam("userrole", $("#userrole option:selected").val());
			comSubmit.addParam("message", $("#message").val());
			comSubmit.submit();			
		}

		function fn_deleteUser(){
			var comSubmit = new ComSubmit();
            comSubmit.setUrl("<c:url value='/deleteUser.do' />");
			alert(
			 "DELETE USER \n" +
			 "search = " + $("#searchKey").val() + "\n" +
			 "username = " + $("#username").val() + "\n" +
			 "index = " +  ${p.current_page_no} 
			);
			comSubmit.addParam("username", $("#username").val());
            comSubmit.addParam("searchKey", $("#searchKey").val());
            comSubmit.addParam("index", ${p.current_page_no});
            comSubmit.submit();			
		}
		
		
		
		
		
		

        window.onload = function() {
		    // 현재번호 active
		    var current_page_no = document.getElementById("current_page_no").value;
		    var pageIndex = document.querySelector('.pageIndex'+(Number(current_page_no)+1));
		    pageIndex.setAttribute("class", "active");
		    // 리스트갯수 selected 처리
		    $("#listCount > option").each(function () {
		        if ($(this).val() == $('#listCnt').val()) {
		            $(this).prop("selected", true);
		        }
		    });
			<c:choose>
			<c:when test="${fn:length(refMetaList) > 0}">
				draw();
			</c:when>
			<c:otherwise>
			$("#mynetwork").css('visibility','hidden');
			$("#mynetwork").css('width','0%');
			$("#mynetwork").css('height','0%');
			</c:otherwise>
			</c:choose>

		}
	        
    </script>
	
<script src="<c:url value='/js/tagcloud.js'/>"></script>
<script>
        $("#tagcloud a").tagcloud();

        $('#tagForm').submit(function() {
            $("#tagcloud a").tagcloud({
                size: {
                    start: parseInt($('#minFont').val()),
                    end: parseInt($('#maxFont').val()),
                    unit: $('#unit').val()
                },
                color: {
                    start: "#" + $('#startColour').val(),
                    end: "#" + $('#endColour').val()
                }
            })
            return false;
        })

    </script>
<script type="text/javascript">

  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', 'UA-36251023-1']);
  _gaq.push(['_setDomainName', 'jqueryscript.net']);
  _gaq.push(['_trackPageview']);

  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();

</script>

</body>
</html>